//////////////////////////////////////////////////////////////////////////
// Txt2mpad - Text to BB Memopad backup file converter
//////////////////////////////////////////////////////////////////////////
#include <windows.h>
#include "txt2mpad.h"

OPENFILENAME OFN; // Globals
char Fname[MAX_PATH]="";
char Iname[MAX_PATH]="";
char Sname[32];
DWORD Fsize=0;

void ErBox(char *E)
{
  MessageBox(NULL,E,"ERROR",MB_ICONERROR);
}

LRESULT CALLBACK WndProc(HWND hwnd,UINT msg,WPARAM wParam,LPARAM lParam)
{
  switch (msg)
  {
    case WM_CREATE:  // Initialization
    {
      HWND hEdit;
      HFONT hfDefault;
      hEdit = CreateWindowEx(WS_EX_CLIENTEDGE, "EDIT", "", WS_CHILD|WS_VISIBLE|WS_VSCROLL|WS_HSCROLL|ES_MULTILINE|ES_AUTOVSCROLL|ES_AUTOHSCROLL, 0, 0, 64, 64, hwnd, (HMENU)IDC_MAIN_EDIT, GetModuleHandle(NULL), NULL);
      if (hEdit == NULL) ErBox("EditBox Creation Failed!");
      hfDefault = GetStockObject(DEFAULT_GUI_FONT);
      SendMessage(hEdit,WM_SETFONT,(WPARAM)hfDefault,MAKELPARAM(FALSE,0));
      ZeroMemory(&OFN,sizeof(OFN)); // Clear structure
      OFN.hwndOwner = hwnd;         // Common OFN parts
      OFN.lpstrFile = Fname;        // Long filename
      OFN.nMaxFile = MAX_PATH;      // Long filename's max len
      OFN.lpstrFileTitle = Sname;   // Short filename
      OFN.nMaxFileTitle = 32;       // Short filename's max len
      OFN.lpstrDefExt = "ipd";
      OFN.lStructSize = sizeof(OPENFILENAME);
    }
      break;
    case WM_COMMAND:
      switch (LOWORD(wParam))
      {
        case ID_NEW: // NEW file
          Fsize = 0;
          SetDlgItemText(hwnd,IDC_MAIN_EDIT,"");
          break;
        case ID_LOAD: // LOAD text file
        {
          OFN.Flags = OFN_EXPLORER|OFN_FILEMUSTEXIST|OFN_HIDEREADONLY;
          OFN.lpstrFilter = "All Files (*.*)\0*.*\0";
          if (GetOpenFileName(&OFN))
          {
            HANDLE hFile;
            hFile = CreateFile(Fname,GENERIC_READ,FILE_SHARE_READ,NULL,OPEN_EXISTING,0,NULL);
            if (hFile != INVALID_HANDLE_VALUE)
            {
              Fsize = GetFileSize(hFile,NULL);
              if (Fsize != 0xFFFFFFFF)
              {
                LPSTR pszFtext;
                pszFtext = GlobalAlloc(GPTR,Fsize+1);
                if (pszFtext != NULL)
                {
                  DWORD dwRead;
                  if (ReadFile(hFile,pszFtext,Fsize,&dwRead,NULL))
                  {
                    pszFtext[Fsize]=0; // Add null terminator
                    SetWindowText(GetDlgItem(hwnd,IDC_MAIN_EDIT),pszFtext);
                  }
                  GlobalFree(pszFtext);
                }
                else ErBox("No memory available");
              }
              CloseHandle(hFile);
            }
          }
        }
          break;
        case ID_SAVE: // SAVE text file
        {
          DWORD dlen;
          dlen = GetWindowTextLength(GetDlgItem(hwnd,IDC_MAIN_EDIT));
          if (dlen>0) // Skip if no text
          {
            OFN.Flags = OFN_EXPLORER|OFN_PATHMUSTEXIST|OFN_HIDEREADONLY|OFN_OVERWRITEPROMPT;
            OFN.lpstrFilter = "All Files (*.*)\0*.*\0";
            if (GetSaveFileName(&OFN))
            {
              HANDLE hFile;
              hFile = CreateFile(Fname,GENERIC_WRITE,0,NULL,CREATE_ALWAYS,FILE_ATTRIBUTE_NORMAL,NULL);
              if (hFile != INVALID_HANDLE_VALUE)
              {
                LPSTR pszText;
                DWORD dwBufSize = dlen+1;
                pszText = GlobalAlloc(GPTR,dwBufSize);
                if (pszText != NULL)
                {
                  if (GetWindowText(GetDlgItem(hwnd,IDC_MAIN_EDIT),pszText,dwBufSize))
                  {
                    DWORD dwCW; // Chrs written
                    WriteFile(hFile,pszText,dlen,&dwCW,NULL);
                  }
                  GlobalFree(pszText);
                }
              CloseHandle(hFile);
              }
            }
          }
          else ErBox("No text available");
        }
          break;
        case ID_EXPORT: // EXPORT AS .IPD BACKUP FILE
        {
          char Tname[32]; // Temp name
          DWORD dlen;
          dlen = GetWindowTextLength(GetDlgItem(hwnd,IDC_MAIN_EDIT))+1;
          if (dlen>1) // Skip if no text
          {
            if(Fname[0])
            {
              strcpy(Tname,Sname); // Store Sname into Tname (Temp)
              strcpy(Iname,Fname); // Store Fname into Iname
              if(strchr(Fname,'.')!=NULL) memcpy(strrchr(Fname,'.'),".ipd",4); // Change type on Fname
              else strcat(Fname,".ipd");
            }
            else strcpy(Tname,"Name.txt"); // Default name
            OFN.Flags = OFN_EXPLORER|OFN_PATHMUSTEXIST|OFN_HIDEREADONLY|OFN_OVERWRITEPROMPT;
            OFN.lpstrFilter = "BB Backup Files (*.ipd)\0*.ipd\0All Files (*.*)\0*.*\0";
            if (GetSaveFileName(&OFN))
            {
              HANDLE hFile;
              hFile = CreateFile(Fname,GENERIC_WRITE,0,NULL,CREATE_ALWAYS,FILE_ATTRIBUTE_NORMAL, NULL);
              if (hFile != INVALID_HANDLE_VALUE)
              {
                DWORD dwCW;    // Chrs Written
                LPSTR pszText; // Pointer to data
                short nlen;    // name len
                int rlen;      // record len (total)
                nlen = strlen(Tname)+1; // Get original name len
                WriteFile(hFile,"Inter@ctive Pager Backup/Restore File\x0A\x02\0\x01\0\x06\0Memos\0\0\0",52,&dwCW,NULL); // Write header
                rlen = nlen + dlen+1 +1 +4 +1 +2 +4;     // Calc Rec len
                WriteFile(hFile,&rlen,4,&dwCW,NULL);     // Write Rec len
                WriteFile(hFile,"\0\0\0\0\0\0\0",7,&dwCW,NULL);
                WriteFile(hFile,&nlen,2,&dwCW,NULL);     // Write Name len
                WriteFile(hFile,"\x01",1,&dwCW,NULL);    // Write Field # 1
                WriteFile(hFile,&Tname,nlen,&dwCW,NULL); // Write Name
                WriteFile(hFile,&dlen,2,&dwCW,NULL);     // Write Name len
                WriteFile(hFile,"\x02",1,&dwCW,NULL);    // Write Field # 2
                DWORD dwBufSize = dlen+1;
                pszText = GlobalAlloc(GPTR,dwBufSize);
                if (pszText != NULL)
                {
                  if (GetWindowText(GetDlgItem(hwnd,IDC_MAIN_EDIT),pszText,dwBufSize))
                  {
                    WriteFile(hFile,pszText,dlen,&dwCW,NULL);
                    MessageBox(NULL,"File exported","",0);
                  }
                  GlobalFree(pszText);
                }
              CloseHandle(hFile);
              }
              else ErBox("Invalid file");
            }
            if(Fname[0]) strcpy(Fname,Iname); // Restore Fname from Iname
          }
          else ErBox("No text available");
        }
          break;
        case ID_ABOUT: // ABOUT box
          MessageBox(NULL,"Text to Memopad .IDP backup file converter","Txt2mpad",0);
          break;
        case ID_EXIT:
          PostMessage(hwnd, WM_CLOSE, 0, 0);
          break;
      }
      break;
    case WM_SIZE:
    {
      RECT rcClient;
      GetClientRect(hwnd,&rcClient);
      SetWindowPos(GetDlgItem(hwnd,IDC_MAIN_EDIT),NULL,0,0,rcClient.right,rcClient.bottom,SWP_NOZORDER);
    }
      break;
    case WM_CLOSE:
      DestroyWindow(hwnd);
      break;
    case WM_DESTROY:
      PostQuitMessage(0);
      break;
    default:
      return DefWindowProc(hwnd,msg,wParam,lParam);
  }
  return 0;
}

int PASCAL WINAPI WinMain(HINSTANCE hInst,HINSTANCE hPI,LPSTR CL,int CS)
{
  MSG Msg;
  HWND hwnd;
  WNDCLASSEX WC;
  WC.style = 0;
  WC.cbWndExtra = 0;
  WC.hInstance = hInst;
  WC.lpfnWndProc = WndProc;
  WC.lpszClassName = "WndCls";
  WC.cbSize = sizeof(WNDCLASSEX);
  WC.hCursor = LoadCursor(NULL,IDC_ARROW);
  WC.hIcon = LoadIcon(NULL,IDI_APPLICATION);
  WC.hIconSm = LoadIcon(NULL,IDI_APPLICATION);
  WC.hbrBackground = (HBRUSH)(COLOR_WINDOW+1);
  WC.lpszMenuName = MAKEINTRESOURCE(IDR_MAINMENU);
  if (!RegisterClassEx(&WC))
  {
    ErBox("Window Registration Failed!");
    return 0;
  }
  hwnd = CreateWindowEx(0,"WndCls","Txt2mpad",WS_OVERLAPPEDWINDOW,CW_USEDEFAULT,CW_USEDEFAULT,768,512,NULL,NULL,hInst,NULL);
  if (hwnd == NULL)
  {
    ErBox("Window Creation Failed!");
    return 0;
  }
  ShowWindow(hwnd,CS);
  UpdateWindow(hwnd);
  while (GetMessage(&Msg,NULL,0,0)>0)
  {
    TranslateMessage(&Msg);
    DispatchMessage(&Msg);
  }
  return Msg.wParam;
}
